const webpack = require('webpack');

exports.build = function () {
    let config_web = require("./build.web").build();
    let config_native = require("./build.native").build();
    let compiler = webpack(config_web);

    return Promise.all([
        new Promise(function(resolve){
            if(config_native!==undefined){
                webpack(config_native, function(){
                    resolve();
                })
            }else{
                resolve()
            }
        }),
        new Promise(function (resolve) {
            if(process.env.NODE_ENV==="dev"){
                global.middleware = [];

                const devModule = require("webpack-dev-middleware")(compiler,{
                    noInfo: true,log:false
                });
                global.middleware.push(devModule);

                devModule.waitUntilValid(() => {
                    resolve()
                });

                global.middleware.push(require("webpack-hot-middleware")(compiler,{
                    noInfo: true,log:false
                }))
            }else{
                resolve();
            }
        })
    ])
};
