const config = require("./webpack.config");
const merge  = require("webpack-merge");
const webpack = require('webpack');

let webpackConfig = merge(config,{
    module: {
        rules: [{
            test: /\.vue(\?[^?]+)?$/,
            loader: 'weex-loader',
            options: {
                loaders: {
                    js: "babel-loader?presets[]=es2015&presets[]=stage-0"
                }
            }
        }],
    },
    output: {
        path: light.config.dist,
        filename: '[name].native.js'
    },
    plugins:[
        new webpack.BannerPlugin({
            banner: '// { "framework": "Vue" }\n',
            raw: true
        }),
        new webpack.DefinePlugin({
            'process.env.RUNTIME': JSON.stringify("native"),
            'process.env.NODE_ENV': JSON.stringify(process.env.NODE_ENV),
            '__ENV__':require("./env")(light.options.env || 'default')
        }),
    ],
    externals: {
        vue: 'Vue'
    },
});

if (process.env.NODE_ENV === "dev") {
    webpackConfig = merge({
        watch: true,
        watchOptions: {
            ignored: "app.native.js"
        }
    },webpackConfig)
}

module.exports = {
    build(){
        if(process.argv.indexOf("--native")<0 && (!light.config.plugins || light.config.plugins.indexOf("jsnative")<0)){
            //不存在weex参数且没有jsnaitve插件，不编译
            return undefined;
        }
        // if(light.config.plugins&&light.config.plugins.indexOf("native")<0){
        //     //不是native工程，不编译
        //     return Promise.resolve();
        // }

        light.util.log("info","准备编译weex环境下的jsnative文件...");

        return webpackConfig;
    }
};